#!/usr/local/bin/perl

#
# Converts human-readable comments to a form importable by MS-Access
# outputs to stdout
#
# usage:
# cimport.pl comments.txt startnum date

$progname = "cimport.pl";
$argc = scalar(@ARGV);

if ($argc != 3) {
	printf("Usage: $progname commentfile.txt startnum date\n");
	exit(1);
}

open(cfile, @ARGV[0]) or die "Can't open stack file @ARGV[0]: $!\n";

# states:
# 0: none
# 1: Last Name
# 2: First Name
# 3: Start Page
# 4: Start Line
# 5: T/E
# 6: Description
# 7: Reason

$nc = 0; #cummulative number of comments
$state = 0;
$ci = @ARGV[1]; #comment index
$date = @ARGV[2];
#@descr[0] = "nothing";
#@reason[0] = "nothing";

#print the field headings
print "\@Number\@|\@Last Name\@|\@First Name\@|\@Page Number\@|\@Line Number\@|\@Description of Edit\@|\@Reason for Edit\@|\@Date Received\@|\@Resolution\@|\@Date Resolved\@|\@Comment Type\@|\@Notes\@|\@Document\@\n";

# print a comment record
sub printc {
	print "$ci|\@$last\@|\@$first\@|$page|$line|\@";
	foreach $line (@descr) { print $line; }
	print "\@|\@";
	foreach $line (@reason) { print $line; }
	print "\@|";
	print "$date 0:00:00|\@unresolved\@||\@$type\@||\@802.16.3f-00/01\@\n";
}

while (<cfile>) {
	if (/^\[.*Last/) { 
		if ($state == 7) {
			$#descr--;	#remove extra line
			$#reason--;	#remove extra line
			printc();
			$ci++;
		}
		$state = 1; $nc++; next; 
	}

	if (/^\[.*First/) { $state = 2; next; }

	if (/^\[Starting Page/) { $state = 3; next; }

	if (/^\[Starting Line/) { $state = 4; next; }

	if (/^\[\(T/) { $state = 5; $_ = <cfile>; next; } # eat an extra line

	if (/^\[Detailed/) { $state = 6; next; }

	if (/^\[Reason/) { $state = 7; next; }

	if ($state == 1) { chomp($last = $_); $state = 0; $#descr = 0; $#reason = 0; next; }

	if ($state == 2) { chomp($first = $_); $state = 0; next; }

	if ($state == 3) { 
		chomp($page = $_); 

		if (!($page =~ /^[0-9]*$/)) {
			print STDERR "Line ", $. ,": Invalid page number\n";
		}
		$state = 0; 
		next;
	}

	if ($state == 4) { 
		chomp($line = $_);

		if (!($line =~ /^[0-9]*$/)) {
			print STDERR "Line ", $. ,": Invalid line number\n";
		}
		$state = 0; 
		next; 
	}
	if ($state == 5) {
		if (/T/) { $type = "Technical"; } 
			else { $type = "Editorial"; }
		$state = 0;
		next;
	}

	if ($state == 6) {
		$x = $#descr;
		@descr[$x+1] = $_;
		next;
	}

	if ($state == 7) {
		$x = $#reason;
		@reason[$x+1] = $_;
		next;
	}
}

printc();

print STDERR "$nc comments processed; last index=$ci\n";

